#include <GyverEncoder.h>
#include <LiquidCrystal.h>
#include <Ultrasonic.h>

LiquidCrystal lcd(12, 11, 5, 4, 3, 2);
Encoder enc(8, 10, 9);
Ultrasonic sonic(6, 7);

uint32_t upd = 0;
boolean flag = true;
boolean flag_prog = false;
boolean flag_timer = false;
boolean flag_guess = true;
int timer_min = 0;
int timer_sec = 0;
int stopwatch_sec = 0;
int stopwatch_min = 0;
byte upd_stopwatch = 1;
byte punt = 1;
byte upd_timer = 1;
byte text_id = 1;
byte timer_punt = 1;
byte upd_del = 100;
byte punt_max = 5;
byte punt_min = 1;
byte guess = 0;
byte guess_enc = 0;
byte guess_punt = 1;

//Настройки
String text1 = "My name's CHW!!!";
String text2 = "by ChudoWindows";
String text3 = "I love computer";
//Настрйки

void setup() {
  enc.setType(TYPE2);
  enc.setTickMode(AUTO);
  lcd.begin(16, 2);
  lcd.setCursor(4, 0);
  lcd.print("COMPUTER");
  lcd.setCursor(0, 1);
  lcd.print("by CHW is Craf");
  delay(1000);
  lcd.clear();
  upd = millis();
}

void loop() {
  encoder();
  program();
  if (millis() - upd > upd_del) {
    upd = millis();
    menu(punt);
  }
}

void menu(byte punkt) {
  if (flag_prog == false) {
    switch (punkt) {
      case 1:
        lcd.clear();
        lcd.setCursor(3, 0);
        lcd.print("<- TIMER ->");
        break;
      case 2:
        lcd.clear();
        lcd.setCursor(1, 0);
        lcd.print("<- STOPWATCH ->");
        break;
      case 3:
        lcd.clear();
        lcd.setCursor(3, 0);
        lcd.print("<- TEXT ->");
        break;
      case 4:
        lcd.clear();
        lcd.setCursor(1, 0);
        lcd.print("<- DISTANCE ->");
        break;
      case 5:
        lcd.clear();
        lcd.setCursor(3, 0);
        lcd.print("<- GUESS ->");
        break;
    }
  }
}

void encoder() {
  if (flag_prog == false && flag && enc.isRight()) {
    if (punt < punt_max) {
      punt++;
    }
  }
  if (flag_prog == false && flag && enc.isLeft()) {
    if (punt > punt_min) {
      punt--;
    }
  }
  if (flag_prog == false && enc.isDouble()) {
    flag = !flag;
  }
  if (enc.isClick()) {
    flag_prog = true;
    upd = millis();
  }
  if (flag_prog == true && punt == 1 && enc.isRight()) {
    timer_sec++;
    if (timer_sec == 60) {
      timer_sec = 0;
      timer_min++;
    }
  }
  if (flag_prog == true && punt == 1 && enc.isLeft()) {
    if (timer_min != 0) {
      if (timer_sec == 0) {
        timer_min--;
        timer_sec = 59;
      } else {
        timer_sec--;
      }
    } else {
      if (timer_sec != 0) {
        timer_sec--;
      }
    }
  }
  if (flag_prog == true && punt == 1 && enc.isClick()) {
    timer_punt = 2;
    flag_timer = true;
  }
  if (flag_prog && punt == 2 && enc.isClick() or enc.isHolded()) {
    flag_prog = false;
    stopwatch_sec = 0;
    stopwatch_min = 0;
  }
  if (flag_prog && punt == 3 && enc.isRight()) {
    if (text_id != 3) {
      text_id++;
    }
  }
  if (flag_prog && punt == 3 && enc.isLeft()) {
    if (text_id != 1) {
      text_id--;
    }
  }
  if (flag_prog && punt == 3 && enc.isClick() or enc.isHolded()) {
    flag_prog = false;
    text_id = 1;
  }
  if (flag_prog && punt == 4 && enc.isClick() or enc.isHolded()) {
    flag_prog = false;
    upd_del = 100;
  }
  if (flag_prog && punt == 5 && enc.isClick() or enc.isHolded()) {
    if (guess_punt == 3) {
      flag_prog = false;
      flag_guess = true;
      guess_enc = 0;
      guess_punt = 1;
    } else {
      guess_punt++;
    }
  }
  if (flag_prog && punt == 5 && enc.isRight()) {
    if (guess_enc != 9) {
      guess_enc++;
    }
  }
  if (flag_prog && punt == 5 && enc.isLeft()) {
    if (guess_enc != 0) {
      guess_enc--;
    }
  }
}

void program() {
  if (flag_prog == true && punt == 1 && millis() - upd > 100) {
    upd = millis();
    lcd.clear();
    timer_p();
  }
  if (flag_prog == true && punt == 2 && millis() - upd > 100) {
    upd = millis();
    lcd.clear();
    stopwatch_p();
  }
  if (flag_prog == true && punt == 3 && millis() - upd > 100) {
    lcd.clear();
    text_p();
  }
  if (flag_prog == true && punt == 4 && millis() - upd > 100) {
    lcd.clear();
    upd_del = 500;
    dis_p();
  }
  if (flag_prog == true && punt == 5 && millis() - upd > 100) {
    if (flag_guess) {
      lcd.clear();
    }
    guess_p();
  }
}

void timer_p() {
  if (timer_punt == 1) {
    lcd.print("TIMER ON:");
    lcd.setCursor(0, 1);
    if (timer_sec < 10) {
      lcd.print(timer_min);
      lcd.print(":0");
      lcd.print(timer_sec);
    } else {
      lcd.print(timer_min);
      lcd.print(":");
      lcd.print(timer_sec);
    }
  }
  if (flag_timer == true && timer_punt == 2) {
    if (upd_timer != 10) {
      upd_timer++;
    } else {
      upd_timer = 1;
      if (timer_sec == 0) {
        timer_min--;
        timer_sec = 59;
      } else {
        timer_sec--;
      }
    }
    if (timer_sec == 0 && timer_min == 0) {
      timer_sec = 0;
      timer_min = 0;
      flag_prog = false;
      flag_timer = false;
      timer_punt = 1;
    }
    lcd.clear();
    lcd.print("TIMER:");
    lcd.setCursor(0, 1);
    if (timer_sec < 10) {
      lcd.print(timer_min);
      lcd.print(":0");
      lcd.print(timer_sec);
    } else {
      lcd.print(timer_min);
      lcd.print(":");
      lcd.print(timer_sec);
    }
  }
}

void stopwatch_p() {
  if (upd_stopwatch == 10) {
    upd_stopwatch = 1;
    stopwatch_sec++;
  } else {
    upd_stopwatch++;
  }
  if (stopwatch_sec == 60) {
    stopwatch_min++;
    stopwatch_sec = 0;
  }

  lcd.clear();
  lcd.print("STOPWATCH:");
  lcd.setCursor(0, 1);
  if (stopwatch_sec < 10) {
    lcd.print(stopwatch_min);
    lcd.print(":0");
    lcd.print(stopwatch_sec);
  } else {
    lcd.print(stopwatch_min);
    lcd.print(":");
    lcd.print(stopwatch_sec);
  }
}

void text_p() {
  if (text_id == 1) {
    lcd.clear();
    lcd.print("Text id: 1");
    lcd.setCursor(0, 1);
    lcd.print(text1);
  }
  if (text_id == 2) {
    lcd.clear();
    lcd.print("Text id: 2");
    lcd.setCursor(0, 1);
    lcd.print(text2);
  }
  if (text_id == 3) {
    lcd.clear();
    lcd.print("Text id: 3");
    lcd.setCursor(0, 1);
    lcd.print(text3);
  }
}
void dis_p() {
  lcd.clear();
  lcd.print("DISTANCE IN CM:");
  lcd.setCursor(0, 1);
  lcd.print(sonic.read());
}
void guess_p() {
  if (guess_punt == 1) {
    guess = random(0, 9);
    lcd.print("Your number: ");
    lcd.print(guess_enc);
  } else if (guess_punt == 2) {
    guess_punt++;
    flag_guess = false;
    if (guess == guess_enc) {
      lcd.print("Correctly");
    } else {
      lcd.print("Wrong");
    }
  }
}
